package com.qmth.paper.library.business.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qmth.paper.library.business.bean.result.PaperScanTaskResult;
import com.qmth.paper.library.business.entity.PaperScanTask;
import com.qmth.paper.library.common.bean.result.BasicStudentResult;
import org.apache.ibatis.annotations.Param;

import java.util.Set;

/**
 * <p>
 * 扫描任务表 Mapper 接口
 * </p>
 */
public interface PaperScanTaskMapper extends BaseMapper<PaperScanTask> {

    /**
     * 扫描任务分页查询
     *
     * @param iPage       分页参数
     * @param schoolId    学校id
     * @param courseName  课程名称
     * @param teacherName 教师名称
     * @param orgIds      数据权限
     * @return 分页查询结果
     */
    IPage<PaperScanTaskResult> findPaperScanTaskPage(@Param("iPage") Page<PaperScanTaskResult> iPage,
                                                     @Param("schoolId") Long schoolId,
                                                     @Param("courseName") String courseName,
                                                     @Param("teacherName") String teacherName,
                                                     @Param("orgIds") Set<Long> orgIds);
}
