package com.qmth.paper.library.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.paper.library.business.bean.result.PaperLibraryResult;
import com.qmth.paper.library.business.entity.PaperLibrary;
import com.qmth.paper.library.business.entity.PaperScanTaskDetail;
import com.qmth.paper.library.business.mapper.PaperLibraryMapper;
import com.qmth.paper.library.business.service.PaperLibraryService;
import com.qmth.paper.library.business.service.PaperScanTaskDetailService;
import com.qmth.paper.library.common.entity.SysUser;
import com.qmth.paper.library.common.enums.ExceptionResultEnum;
import com.qmth.paper.library.common.util.ServletUtil;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * <p>
 * 图片库 服务实现类
 * </p>
 */
@Service
public class PaperLibraryServiceImpl extends ServiceImpl<PaperLibraryMapper, PaperLibrary> implements PaperLibraryService {

    @Resource
    PaperScanTaskDetailService paperScanTaskDetailService;

    @Override
    public IPage<PaperLibraryResult> pageUnbindData(Long paperScanTaskId, Integer pageNumber, Integer pageSize) {
        return this.baseMapper.pageUnbindData(new Page<>(pageNumber, pageSize), paperScanTaskId);
    }

    @Override
    public int countUnbindData(Long paperScanTaskId) {
        return this.baseMapper.countUnbindData(paperScanTaskId);
    }

    @Override
    public IPage<PaperLibraryResult> pageBindData(Long paperScanTaskId, Integer pageNumber, Integer pageSize) {
        return this.baseMapper.pageBindData(new Page<>(pageNumber, pageSize), paperScanTaskId);
    }

    @Override
    public int countBindData(Long paperScanTaskId) {
        return this.baseMapper.countBindData(paperScanTaskId);
    }

    @Override
    public boolean bind(Long paperLibraryId, Long paperScanTaskDetailId) {
        SysUser sysUser = (SysUser) ServletUtil.getRequestUser();

        PaperScanTaskDetail paperScanTaskDetail = paperScanTaskDetailService.getById(paperScanTaskDetailId);
        if (paperScanTaskDetail == null) {
            throw ExceptionResultEnum.ERROR.exception("绑定对象有误，任务下无该考生，请刷新数据再试");
        }
        UpdateWrapper<PaperLibrary> updateWrapper = new UpdateWrapper<>();
        updateWrapper.lambda().set(PaperLibrary::getPaperScanTaskDetailId, paperScanTaskDetailId)
                .eq(PaperLibrary::getId, paperLibraryId);
        return this.update(updateWrapper);
    }

}
